## mingw-w64-simvoleon-2.1.0-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

set(SIMVOLEON_MAJOR_VERSION 2)
set(SIMVOLEON_MINOR_VERSION 1)
set(SIMVOLEON_MICRO_VERSION 0)
set(SIMVOLEON_BETA_VERSION )
set(SIMVOLEON_VERSION ${SIMVOLEON_MAJOR_VERSION}.${SIMVOLEON_MINOR_VERSION}.${SIMVOLEON_MICRO_VERSION}${SIMVOLEON_BETA_VERSION})

project(SIMVoleon VERSION ${SIMVOLEON_MAJOR_VERSION}.${SIMVOLEON_MINOR_VERSION}.${SIMVOLEON_MICRO_VERSION})
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

# ############################################################################
# these will be removed after upgrading CMake minimum version to 3.9.6
set(PROJECT_DESCRIPTION   "A volume rendering library for Coin")
# ############################################################################
 
string(TIMESTAMP SIMVOLEON_BUILD_YEAR "%Y")
math(EXPR SIMVOLEON_SO_VERSION ${PROJECT_VERSION_MAJOR}*20)
set(VERSION ${SIMVOLEON_VERSION})

if(POLICY CMP0072)
  # get rid of OpenGL GLVND warning from CMake 3.11
  cmake_policy(SET CMP0072 NEW)
endif()

if(POLICY CMP0075)
  # get rid of CMAKE_REQUIRED_LIBRARIES warning from CMake 3.12
  cmake_policy(SET CMP0075 NEW)
endif()

# ############################################################################
# Prevent in-source builds, as they often cause severe build problems
# ############################################################################

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "${CMAKE_PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake <path_to_${CMAKE_PROJECT_NAME}> [options]' from there.")
endif()

# ############################################################################
# Include necessary submodules
# ############################################################################

include(CheckCXXSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckStructHasMember)
include(CheckSymbolExists)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

# ############################################################################
# Macros & functions
# ############################################################################

function(dump_variable)
  if (OPTION_VERBOSE)
    foreach(f ${ARGN})
      if (DEFINED ${f})
        message("${f} = ${${f}}")
      else()
        message("${f} = ***UNDEF***")
      endif()
    endforeach()
  endif()
endfunction()

function(executable executable_name)
  set(multiValueArgs SOURCES LIBS)
  cmake_parse_arguments(executable "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )
  add_executable(${executable_name} ${executable_SOURCES})
  target_link_libraries(${executable_name} ${executable_LIBS})
  if (HAVE_ASAN)
    target_compile_options(${executable_name} PUBLIC "-fsanitize=address")
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS "-fsanitize=address")
  endif()
endfunction(executable)

function(report_prepare)
  set(multiValueArgs IF_APPLE IF_WIN32)
  cmake_parse_arguments(REPORT "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )
  if (REPORT_IF_APPLE AND APPLE)
    list(APPEND res ${REPORT_IF_APPLE})
  endif()
  if (REPORT_IF_WIN32 AND WIN32)
    list(APPEND res ${REPORT_IF_WIN32})
  endif()
  list(APPEND res ${REPORT_UNPARSED_ARGUMENTS})
  list(APPEND PACKAGE_OPTIONS ${res})
  set(PACKAGE_OPTIONS "${PACKAGE_OPTIONS}" PARENT_SCOPE)
endfunction(report_prepare)

# ############################################################################
# Provide options to customise the build
# ############################################################################

option(OPTION_VERBOSE "Verbose build " OFF)
option(SIMVOLEON_BUILD_SHARED_LIBS "Build shared libraries" ON)
option(SIMVOLEON_BUILD_DOCUMENTATION "Build and install API documentation (requires Doxygen)." OFF)
option(SIMVOLEON_BUILD_TESTS "Build test code" OFF)
cmake_dependent_option(SIMVOLEON_BUILD_INTERNAL_DOCUMENTATION "Document internal code not part of the API." OFF "SIMVOLEON_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(SIMVOLEON_BUILD_DOC_MAN "Build So${Gui} man pages." OFF "SIMVOLEON_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(SIMVOLEON_BUILD_DOC_QTHELP "Build QtHelp documentation." OFF "SIMVOLEON_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(SIMVOLEON_BUILD_DOC_CHM "Build compressed HTML help manual (requires HTML help compiler)" OFF "SIMVOLEON_BUILD_DOCUMENTATION" OFF)

report_prepare(
  SIMVOLEON_BUILD_SHARED_LIBS
  SIMVOLEON_BUILD_DOCUMENTATION
  SIMVOLEON_BUILD_TESTS
  SIMVOLEON_BUILD_INTERNAL_DOCUMENTATION
  SIMVOLEON_BUILD_DOC_MAN
  SIMVOLEON_BUILD_DOC_QTHELP
  SIMVOLEON_BUILD_DOC_CHM
)

# ############################################################################
# Find all necessary and optional dependencies
# ############################################################################

find_package(OpenGL REQUIRED) # FIXME really needed?
find_package(Coin REQUIRED)
if (SIMVOLEON_BUILD_TESTS)
  set(Gui "Qt" CACHE STRING "Target GUI for the example code")
  set(GuiValues "Qt;Xt;Win" CACHE INTERNAL "List of possible values for the GUI cache variable")
  set_property(CACHE Gui PROPERTY STRINGS ${GuiValues})
  message(STATUS "Example Gui set to '${Gui}'")
  if (Gui STREQUAL "Qt")
    message(WARNING "SoQt GUI binding examples WILL CRASH")
    set(GUI QT)
    find_package(SoQt)
    set(EXAMPLE_LINK_LIB SoQt::SoQt)
  elseif(Gui STREQUAL "Xt")
    set(GUI XT)
    find_package(SoXt)
    set(EXAMPLE_LINK_LIB SoXt::SoXt)
  elseif(Gui STREQUAL "Win")
    message(WARNING "SoWin GUI binding NOT TESTED")
    set(GUI WIN)
    find_package(SoWin)
    set(EXAMPLE_LINK_LIB SoWin::SoWin)
  else()
    message(FATAL_ERROR "Only Qt,Win and Xt supported: please set Gui at one of these values")
  endif()
  find_package(GLUT) # needed only for testcode/tabula/glutclut.c
endif()

# ##########################################################################
# Setup build environment
# ##########################################################################

if(NOT CMAKE_BUILD_TYPE)
  # Has no effect for multi configuration generators (VisualStudio, Xcode).
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose type of build, options are Debug, Release, RelWithDebInfo, MinSizeRel." FORCE)
endif()

check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(dlfcn.h HAVE_DLFCN_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(memory.h HAVE_MEMORY_H)
if(HAVE_SYS_TYPES_H)
  check_cxx_source_compiles("
    #include <sys/types.h>
    #include <pthread.h>
    int main() { struct timespec timeout; timeout.tv_nsec = 0; return 0; }
  " HAVE_PTHREAD_TIMESPEC_NSEC)
else()
  check_cxx_source_compiles("
    #include <pthread.h>
    int main() { struct timespec timeout; timeout.tv_nsec = 0; return 0; }
  " HAVE_PTHREAD_TIMESPEC_NSEC)
endif()
check_cxx_source_compiles("
  int main() {__builtin_expect (x, 0);return 0;}" HAVE___BUILTIN_EXPECT)

check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(string.h HAVE_STRING_H)
check_include_files(sys/stat.h HAVE_SYS_STAT_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files("assert.h;ctype.h;errno.h;float.h;limits.h;locale.h;math.h;setjmp.h;signal.h;stdarg.h;stddef.h;stdio.h;stdlib.h;string.h;time.h" STDC_HEADERS)
# FIXME to be tested if necessary
if(HAVE_WINDOWS_H)
  check_include_files("windows.h;tlhelp32.h" HAVE_TLHELP32_H)
  check_cxx_source_compiles("
    #include <windows.h>
    int main() {
      CreateDirectory(NULL, NULL);
      RemoveDirectory(NULL);
      SetLastError(0);
      GetLastError();
      LocalAlloc(0, 1);
      LocalFree(NULL);
      return 0;
    }
  " HAVE_WIN32_API)
  check_symbol_exists(LoadLibrary windows.h HAVE_WIN32_LOADLIBRARY)
  if(HAVE_WIN32_LOADLIBRARY)
    set(HAVE_DYNAMIC_LINKING 1)
  endif()
  check_symbol_exists(GetEnvironmentVariable windows.h HAVE_GETENVIRONMENTVARIABLE)
endif()
set(USE_EXCEPTIONS ON)

set(PACKAGE ${PROJECT_NAME})
set(PACKAGE_DESCRIPTION "${PROJECT_DESCRIPTION}")
set(PACKAGE_BUGREPORT "coin-support@coin3d.org")
set(PACKAGE_NAME ${PROJECT_NAME})
set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
set(PACKAGE_TARNAME ${PROJECT_NAME_LOWER})
set(PACKAGE_URL "https://bitbucket.org/Coin3D/${PROJECT_NAME_LOWER}")
set(PACKAGE_VERSION ${PROJECT_VERSION})
set(PACKAGE_HOST ${CMAKE_HOST_SYSTEM_PROCESSOR}-${CMAKE_HOST_SYSTEM_NAME})
set(PACKAGE_COMPILER ${CMAKE_CXX_COMPILER})
set(PACKAGE_REQUIREMENTS "Coin, ${PACKAGE_ADDITIONAL_REQUIREMENTS}")

# ############################################################################
# Setup targets in subdirectories
# ############################################################################
add_subdirectory(data)
add_subdirectory(lib)
##### small test programs (to be run interactively)
if (SIMVOLEON_BUILD_TESTS)
  add_subdirectory(testcode)
endif()

############################################################################
# New CPACK section, please see the README file inside cpack.d directory.
add_subdirectory(cpack.d)

=== data/CMakeLists.txt ===
executable(maketestvol SOURCES maketestvol.cpp)
executable(raw2vol SOURCES raw2vol.cpp LIBS Coin::Coin)

=== lib/CMakeLists.txt ===
configure_file(config.h.cmake.in config.h)
configure_file(VolumeViz/C/basic.h.cmake.in VolumeViz/C/basic.h)

macro(strfy _input _postfix)
  set(COIN_INPUT_FILE_NAME ${_input})
  get_filename_component(_basename "${_input}" NAME_WE)
  get_filename_component(_suffix "${_input}" EXT)
  get_filename_component(_path "${_input}" PATH)
  string(SUBSTRING ${_suffix} 1 -1 _suffix)
  string(TOUPPER "${_basename}_${_suffix}_H" COIN_HEADER_DEF)
  string(TOUPPER ${_basename} COIN_TEXTVAR_NAME)
  set(COIN_TEXTVAR_NAME "${COIN_TEXTVAR_NAME}${_postfix}")
  #message(STATUS "Parse: ${CMAKE_CURRENT_SOURCE_DIR}/${_input}")
  FILE(READ ${CMAKE_CURRENT_SOURCE_DIR}/${_input} f0)
  STRING(REGEX REPLACE "\\\\" "\\\\\\\\" f1 "${f0}")
  STRING(REGEX REPLACE "\"" "\\\\\"" f2 "${f1}")
  STRING(REGEX REPLACE "\r?\n" "\\\\n\"\n  \"" COIN_STR_SOURCE_CODE "${f2}")
  configure_file(strfytemplate.cmake.in "${_path}/${_basename}.h")
endmacro()

# Note misc/ must be built after nodes/gradients/.
file(GLOB_RECURSE GRADIENTS LIST_DIRECTORIES false RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/VolumeViz/nodes/gradients/" *.gg)
foreach(_input_file ${GRADIENTS})
  strfy(VolumeViz/nodes/gradients/${_input_file} "_gradient")
endforeach()

file(GLOB_RECURSE HDRS ${CMAKE_CURRENT_SOURCE_DIR}/*.h)
file(GLOB_RECURSE BIN_HDRS ${CMAKE_CURRENT_BINARY_DIR}/*.h)

set(SRCS
  VolumeViz/Coin/gl/CoinGLPerformance.cpp 
  VolumeViz/caches/GLTextureCache.cpp
  VolumeViz/details/ObliqueSliceDetail.cpp
  VolumeViz/details/OrthoSliceDetail.cpp
  VolumeViz/details/VolumeDetail.cpp
  VolumeViz/details/VolumeRenderDetail.cpp
  VolumeViz/details/VolumeSkinDetail.cpp
  VolumeViz/elements/CompressedTexturesElement.cpp
  VolumeViz/elements/GLInterpolationElement.cpp
  VolumeViz/elements/LightingElement.cpp
  VolumeViz/elements/PageSizeElement.cpp
  VolumeViz/elements/PalettedTexturesElement.cpp
  VolumeViz/elements/StorageHintElement.cpp
  VolumeViz/elements/TransferFunctionElement.cpp
  VolumeViz/elements/VoxelBlockElement.cpp
  VolumeViz/nodes/CvrFaceSetRenderP.cpp
  VolumeViz/nodes/CvrIndexedFaceSetRenderP.cpp
  VolumeViz/nodes/CvrIndexedSetRenderBaseP.cpp
  VolumeViz/nodes/CvrIndexedTriangleStripSetRenderP.cpp
  VolumeViz/nodes/CvrNonIndexedSetRenderBaseP.cpp
  VolumeViz/nodes/CvrTriangleStripSetRenderP.cpp
  VolumeViz/nodes/ObliqueSlice.cpp
  VolumeViz/nodes/OrthoSlice.cpp
  # VolumeViz/nodes/ROI.cpp                                 # not yet implemented?
  VolumeViz/nodes/TransferFunction.cpp
  VolumeViz/nodes/VolumeData.cpp
  VolumeViz/nodes/VolumeFaceSet.cpp
  VolumeViz/nodes/VolumeIndexedFaceSet.cpp
  VolumeViz/nodes/VolumeIndexedTriangleStripSet.cpp
  VolumeViz/nodes/volumeraypickintersection.cpp
  VolumeViz/nodes/VolumeRender.cpp
  VolumeViz/nodes/VolumeRendering.cpp
  VolumeViz/nodes/VolumeSkin.cpp
  VolumeViz/nodes/VolumeTriangleStripSet.cpp
  VolumeViz/misc/CentralDifferenceGradient.cpp
  VolumeViz/misc/CLUT.cpp
  VolumeViz/misc/GIMPGradient.cpp
  VolumeViz/misc/GlobalRenderLock.cpp
  VolumeViz/misc/Gradient.cpp
  VolumeViz/misc/ResourceManager.cpp
  VolumeViz/misc/Util.cpp
  VolumeViz/misc/VoxelChunk.cpp
  VolumeViz/readers/VolumeReader.cpp
  VolumeViz/readers/VRMemReader.cpp
  VolumeViz/readers/VRVolFileReader.cpp
  VolumeViz/render/2D/2DTexPage.cpp
  VolumeViz/render/2D/2DTexSubPage.cpp
  VolumeViz/render/2D/PageHandler.cpp
  VolumeViz/render/3D/3DTexCube.cpp
  VolumeViz/render/3D/3DTexSubCube.cpp
  VolumeViz/render/3D/CubeHandler.cpp
  VolumeViz/render/common/Cvr2DPaletteTexture.cpp
  VolumeViz/render/common/Cvr2DRGBATexture.cpp
  VolumeViz/render/common/Cvr3DPaletteGradientTexture.cpp
  VolumeViz/render/common/Cvr3DPaletteTexture.cpp
  VolumeViz/render/common/Cvr3DRGBATexture.cpp
  VolumeViz/render/common/CvrPaletteTexture.cpp
  VolumeViz/render/common/CvrRGBATexture.cpp
  VolumeViz/render/common/CvrTextureObject.cpp
  VolumeViz/render/Pointset/PointRendering.cpp
)

if(WIN32)
  if(MINGW)
    set(SIMVOLEON_DEFAULT_SHARED_POSTFIX "")
    set(SIMVOLEON_DEFAULT_STATIC_POSTFIX "")
  else()
    # On Windows the major version number is part of the library name
    set(SIMVOLEON_DEFAULT_SHARED_POSTFIX ${PROJECT_VERSION_MAJOR})
    set(SIMVOLEON_DEFAULT_STATIC_POSTFIX ${PROJECT_VERSION_MAJOR}s)
  endif()
  if(SIMVOLEON_BUILD_SHARED_LIBS)
    set(SIMVOLEON_DEFAULT_POSTFIX ${SIMVOLEON_DEFAULT_SHARED_POSTFIX})
  else()
    set(SIMVOLEON_DEFAULT_POSTFIX ${SIMVOLEON_DEFAULT_STATIC_POSTFIX})
  endif()
  set(CMAKE_RELEASE_POSTFIX ${SIMVOLEON_DEFAULT_POSTFIX})
  set(CMAKE_MINSIZEREL_POSTFIX ${SIMVOLEON_DEFAULT_POSTFIX})
  set(CMAKE_RELWITHDEBINFO_POSTFIX ${SIMVOLEON_DEFAULT_POSTFIX})
  set(CMAKE_DEBUG_POSTFIX ${SIMVOLEON_DEFAULT_POSTFIX}d)
elseif(APPLE)
else()
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

if(SIMVOLEON_BUILD_SHARED_LIBS)
  add_library(${PROJECT_NAME} SHARED ${HDRS} ${BIN_HDRS} ${SRCS})
else()
  add_library(${PROJECT_NAME} STATIC ${HDRS} ${BIN_HDRS} ${SRCS})
endif()

set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${SIMVOLEON_VERSION} SOVERSION ${SIMVOLEON_SO_VERSION})

target_compile_definitions(${PROJECT_NAME} PRIVATE HAVE_CONFIG_H SIMVOLEON_INTERNAL SIMVOLEON_DEBUG=$<CONFIG:Debug>)

if(WIN32)
  if(MSVC)
    target_compile_definitions(${PROJECT_NAME} PRIVATE _CRT_NONSTDC_NO_DEPRECATE _CRT_SECURE_NO_DEPRECATE _CRT_SECURE_NO_WARNINGS _USE_MATH_DEFINES)
  endif()
  if(SIMVOLEON_BUILD_SHARED_LIBS)
    configure_file(${PROJECT_NAME}.rc.cmake.in ${PROJECT_NAME}.rc)
    target_sources(${PROJECT_NAME} PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.rc")
    target_compile_definitions(${PROJECT_NAME} PRIVATE SIMVOLEON_MAKE_DLL INTERFACE SIMVOLEON_DLL)
  else()
    target_compile_definitions(${PROJECT_NAME} INTERFACE SIMVOLEON_NOT_DLL)
    if(MSVC)
      set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /Z7")                       # Override default /Zi to embed
      set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /Z7")     # debugging info in the .lib.
    endif()
  endif()
endif()

target_include_directories(${PROJECT_NAME}
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>
    ${OPENGL_INCLUDE_DIR}
)

target_link_libraries(${PROJECT_NAME} Coin::Coin ${OPENGL_LIBRARIES})

# Add a target to generate API documentation with Doxygen
if(SIMVOLEON_BUILD_DOCUMENTATION)
  find_package(Doxygen)
  if(NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
  endif()

  set(DOXYGEN_TAGFILES "${Coin_DOC_DIR}/html/Coin.tag=${Coin_DOC_DIR}/html")

# ############################################################################
# Setup documentation options
# ############################################################################
  set(GENERATE_HTMLHELP NO)
  set(DOXYGEN_GENERATE_MAN NO)
  set(GENERATE_QHP NO)
  set(GENERATE_TREEVIEW YES)
  set(HHC_PROGRAM)
  if(WIN32)
    if(SIMVOLEON_BUILD_DOC_CHM)
      find_program(HHC_PROGRAM NAMES hhc.exe PATHS "C:/Program Files/HTML Help Workshop" "C:/Program Files (x86)/HTML Help Workshop" DOC "HTML Help Compiler program")
      if(NOT HHC_PROGRAM)
        message(FATAL_ERROR "Missing program HTML Help Compiler")
      else()
        set(GENERATE_HTMLHELP YES)
        set(GENERATE_TREEVIEW NO)
        mark_as_advanced(HHC_PROGRAM)
      endif()
    endif()
  else()
    if(SIMVOLEON_BUILD_DOC_MAN)
      set(DOXYGEN_GENERATE_MAN YES)
    endif()
  endif()
  if(SIMVOLEON_BUILD_DOC_QTHELP)
    find_program(QHG_LOCATION NAMES qhelpgenerator qhelpgenerator-qt5 DOC "Qt qhelpgenerator")
    if(NOT QHG_LOCATION)
      message(FATAL_ERROR "Missing program Qt qhelpgenerator")
    else()
      set(GENERATE_QHP YES)
      mark_as_advanced(QHG_LOCATION)
    endif()
  endif()

  set(DOXYGEN_INTERNAL_DOCS NO)
  set(DOXYGEN_EXTRACT_PRIVATE NO)
  set(DOXYGEN_WARN_IF_UNDOCUMENTED YES)
  set(DOXYGEN_EXCLUDE)

  set(DOXYFILE "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile")
  set(DOXYGEN_OUTPUT "${CMAKE_BINARY_DIR}/html/index.html")
  configure_file("${PROJECT_SOURCE_DIR}/docs/${PROJECT_NAME_LOWER}.doxygen.cmake.in" ${DOXYFILE} @ONLY)

# ############################################################################
# Setup documentation targets
# ############################################################################
  add_custom_command(
    OUTPUT ${DOXYGEN_OUTPUT}
    COMMAND ${CMAKE_COMMAND} -E echo_append "Generating API documentation with Doxygen "
    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE}
    COMMAND ${CMAKE_COMMAND} -E echo "done."
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
    DEPENDS ${DOXYFILE}
  )
  add_custom_target(documentation ALL DEPENDS ${DOXYGEN_OUTPUT})

# ############################################################################
# Install built documentation files
# ############################################################################
  install(DIRECTORY "${CMAKE_BINARY_DIR}/html" DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation REGEX ".*\\.(chm|qch)" EXCLUDE)
  if(GENERATE_HTMLHELP)
    install(FILES "${CMAKE_BINARY_DIR}/html/${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.chm" DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation)
  endif()
  if(GENERATE_QHP)
    install(FILES "${CMAKE_BINARY_DIR}/html/${PROJECT_NAME}-${PROJECT_VERSION_MAJOR}.qch" DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation)
  endif()
  if(DOXYGEN_GENERATE_MAN)
    install(DIRECTORY "${CMAKE_BINARY_DIR}/man/man3" DESTINATION ${CMAKE_INSTALL_MANDIR} COMPONENT documentation)
    message(STATUS "CMAKE_INSTALL_MANDIR ${CMAKE_INSTALL_MANDIR}")
  endif()
endif()

# ############################################################################
# Install headers
# ############################################################################

set(INST_C_HDRS
  "${CMAKE_CURRENT_BINARY_DIR}/VolumeViz/C/basic.h"
)

set(INST_ELEMENTS_HDRS
  VolumeViz/elements/CvrPageSizeElement.h
  VolumeViz/elements/CvrVoxelBlockElement.h
  VolumeViz/elements/CvrGLInterpolationElement.h
  VolumeViz/elements/CvrLightingElement.h
  VolumeViz/elements/CvrPalettedTexturesElement.h
  VolumeViz/elements/CvrStorageHintElement.h
  VolumeViz/elements/SoTransferFunctionElement.h
  VolumeViz/elements/CvrCompressedTexturesElement.h
)

set(INST_NODES_HDRS
  VolumeViz/nodes/SoVolumeFaceSet.h
  VolumeViz/nodes/SoTransferFunction.h
  VolumeViz/nodes/SoVolumeRender.h
  VolumeViz/nodes/SoVolumeIndexedTriangleStripSet.h
  VolumeViz/nodes/SoVolumeIndexedFaceSet.h
  VolumeViz/nodes/SoVolumeSkin.h
  # VolumeViz/nodes/SoROI.h                             # not yet implemented?!
  VolumeViz/nodes/SoVolumeTriangleStripSet.h
  VolumeViz/nodes/SoObliqueSlice.h
  VolumeViz/nodes/volumeraypickintersection.h
  VolumeViz/nodes/SoOrthoSlice.h
  VolumeViz/nodes/SoVolumeData.h
  VolumeViz/nodes/SoVolumeRendering.h
)

set(INST_MISC_HDRS
  VolumeViz/misc/CvrGlobalRenderLock.h
  VolumeViz/misc/CvrResourceManager.h
  VolumeViz/misc/CvrCentralDifferenceGradient.h
  VolumeViz/misc/Gradient.h
  VolumeViz/misc/CvrVoxelChunk.h
  VolumeViz/misc/CvrUtil.h
  VolumeViz/misc/CvrCLUT.h
  VolumeViz/misc/CvrGradient.h
  VolumeViz/misc/CvrGIMPGradient.h
)

set(INST_DETAILS_HDRS
  VolumeViz/details/SoVolumeDetail.h
  VolumeViz/details/SoVolumeSkinDetail.h
  VolumeViz/details/SoVolumeRenderDetail.h
  VolumeViz/details/SoOrthoSliceDetail.h
  VolumeViz/details/SoObliqueSliceDetail.h
)

set(INST_RENDER_2D_HDRS
  VolumeViz/render/2D/Cvr2DTexPage.h
  VolumeViz/render/2D/CvrPageHandler.h
  VolumeViz/render/2D/texmemfullimg.h
  VolumeViz/render/2D/Cvr2DTexSubPage.h
)

set(INST_RENDER_POINTSET_HDRS
  VolumeViz/render/Pointset/PointRendering.h
)

set(INST_RENDER_COMMON_HDRS
  VolumeViz/render/common/CvrRGBATexture.h
  VolumeViz/render/common/Cvr3DPaletteTexture.h
  VolumeViz/render/common/Cvr2DPaletteTexture.h
  VolumeViz/render/common/CvrPaletteTexture.h
  VolumeViz/render/common/Cvr2DRGBATexture.h
  VolumeViz/render/common/CvrTextureObject.h
  VolumeViz/render/common/Cvr3DRGBATexture.h

=== testcode/CMakeLists.txt ===
add_subdirectory(tabula)
configure_file(doc-example.cpp.in doc-example.cpp @ONLY)
executable(doc-example SOURCES "${CMAKE_CURRENT_BINARY_DIR}/doc-example.cpp" LIBS SIMVoleon ${EXAMPLE_LINK_LIB})

=== testcode/tabula/CMakeLists.txt ===
# executable(glutclut SOURCES glutclut.c LIBS ${GLUT_LIBRARIES})

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.pro>

_realname=simvoleon
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.1.0
pkgrel=1
pkgdesc="A volume rendering library for Coin (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32')
url="https://github.com/coin3d/simvoleon"
license=('custom:coin')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-graphviz"
             "${MINGW_PACKAGE_PREFIX}-doxygen")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-coin")
options=('!strip' 'staticlibs' '!buildflags')
source=("${_realname}-${_realname}-${pkgver}.tar.gz::${url}/archive/${_realname}-${pkgver}.tar.gz"
        "https://raw.githubusercontent.com/coin3d/coincodeshare/2504f60/gl/CoinGLPerformance."{h,cpp}
        '0001-simvoleon-2.1.0-use-cpack-off.patch')
sha256sums=('ab3402cb1afe9842c43d26c33b08a25b4e114db243c27f63b2c87269555f81c5'
            'e6bc455e3ac3f92ca07157ec3b67a33377480f9edf184fc40ab56fbef96b0760'
            '377409159032c1c84c77ebdfdedca84fad8b0899f560669bb0a98a72352c4382'
            '23bdbe0bd84ce7a65704e6471f453912aab8b7a531bbb20450318c408028d882')

prepare() {
  cd "${srcdir}/${_realname}-${_realname}-${pkgver}"

  mkdir -p "lib/VolumeViz/Coin/gl"
  cp -t "lib/VolumeViz/Coin/gl" "${srcdir}/CoinGLPerformance."{h,cpp}

  patch -p1 -i "${srcdir}/0001-simvoleon-2.1.0-use-cpack-off.patch"
}

build() {
  [[ -d "${srcdir}/build-${MSYSTEM}" ]] && rm -rf "${srcdir}/build-${MSYSTEM}"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  "${MINGW_PREFIX}"/bin/cmake.exe \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${extra_config[@]}" \
    -DSIMVOLEON_BUILD_DOCUMENTATION=ON \
    -DSIMVOLEON_BUILD_TESTS=OFF \
    -DSIMVOLEON_EXTRA_LDFLAGS=-lSIMVoleon \
    -DSIMVOLEON_EXTRA_CFLAGS=-DSIMVOLEON_DLL \
    ../${_realname}-${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR=${pkgdir} "${MINGW_PREFIX}"/bin/cmake.exe --install .

  install -Dm644 "${srcdir}/${_realname}-${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}

# vim:set ts=2 sw=2 et:
